//
//  GameViewController.m
//  Game
//
//  Created by Santiago Pavón on 15/11/13.
//  Copyright (c) 2013 UPM. All rights reserved.
//

#import "GameViewController.h"


#define SCORES_URL @"http://localhost:3000/scores.json"


@interface GameViewController ()

@property (weak, nonatomic) IBOutlet UITextField *nameLabel;
@property (weak, nonatomic) IBOutlet UITextField *totalLabel;
@property (weak, nonatomic) IBOutlet UILabel *statusLabel;

@end

@implementation GameViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}



#pragma mark Conectar con el Servidor Web




- (IBAction)save:(id)sender {
    
    self.statusLabel.text = @"Salvando Puntos ...";
    
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:TRUE];
    
    if ([self.nameLabel.text isEqualToString:@""]) self.nameLabel.text = @"Anonimo";
    if ([self.totalLabel.text isEqualToString:@""]) self.totalLabel.text = @"0";
    
    NSString *xscore = [NSString stringWithFormat:@"{\"score\":{\"name\":\"%@\",\"total\":%@}}",
                        self.nameLabel.text,
                        self.totalLabel.text
                        ];
  
    NSString *escapedURL = [SCORES_URL stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    NSURL *url = [NSURL URLWithString:escapedURL];

    NSMutableURLRequest *req = [NSMutableURLRequest requestWithURL:url];
    
    [req setHTTPMethod:@"POST"];
    
    [req addValue:@"application/json; chatset=utf-8" forHTTPHeaderField:@"Content-Type"];
    
    NSString *length = [NSString stringWithFormat:@"%d", [xscore length]];
    [req addValue:length forHTTPHeaderField:@"Content-Length"];
    
    [req setHTTPBody:[xscore dataUsingEncoding:NSUTF8StringEncoding]];
    
    NSURLResponse * response = nil;
    NSError * error = nil;
    
    NSData * data = [NSURLConnection sendSynchronousRequest:req returningResponse:&response error:&error];
    
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:FALSE];
    
    if (data) {
        self.statusLabel.text = @"Salvado";
    } else {
        // Peticion invalida
        self.statusLabel.text = @"Error al salvar";
        NSLog(@"Error de conexion = %@", error);
    }
    
    [self hideKeyboard:nil];
}


- (IBAction) hideKeyboard: (id) sender {
	
	[ (UIView *)sender resignFirstResponder];
	[self.nameLabel resignFirstResponder];
	[self.totalLabel resignFirstResponder];
}




@end
